#include "xparameters.h"
#include "xbasic_types.h"   /* Xilinx basic types for device drivers        */
#include "mb_interface.h"


#define TRUE 1
#define FALSE 0

/*

void WriteAC97Reg( int reg_addr, int value);
int ReadAC97Reg( int reg_addr);
void init_sound(int sample_rate);

volatile int *AC97_InFIFO       = XPAR_OPB_AC97_CONTROLLER_0_BASEADDR;
volatile int *AC97_OutFIFO      = XPAR_OPB_AC97_CONTROLLER_0_BASEADDR + 0x4;
volatile int *AC97_FIFO_Status  = XPAR_OPB_AC97_CONTROLLER_0_BASEADDR + 0x8;
volatile int *AC97_RegAddr      = XPAR_OPB_AC97_CONTROLLER_0_BASEADDR + 0x10;
volatile int *AC97_RegRead      = XPAR_OPB_AC97_CONTROLLER_0_BASEADDR + 0x14;
volatile int *AC97_RegWrite      = XPAR_OPB_AC97_CONTROLLER_0_BASEADDR + 0x18;
#define AC97_InFIFO_Full         0x01
#define AC97_InFIFO_Empty        0x02
#define AC97_Reg_Access_Finished 0x10
#define AC97_CODEC_RDY           0x20
#define AC97_REG_ACCESS          0x40
#define AC97_Enable_In_Intr      0x01

*/
/*
void WriteAC97Reg( int reg_addr, int value) {
  *(AC97_RegWrite) = value;
  *(AC97_RegAddr) = reg_addr;
  while (((*(AC97_FIFO_Status)) & AC97_Reg_Access_Finished) == 0);
}

int ReadAC97Reg( int reg_addr) {
  *(AC97_RegAddr) = reg_addr | 0x80;
  while (((*(AC97_FIFO_Status)) & AC97_Reg_Access_Finished) == 0);
  return *(AC97_RegRead);
}
*/
/*
void init_sound(int sample_rate) {
   while (!((*(AC97_FIFO_Status)) & AC97_CODEC_RDY)) {};
   
   WriteAC97Reg(0x2c, sample_rate); 
   
   WriteAC97Reg(0x2a,1); // Enabling VRA mode
   
   WriteAC97Reg(0x02,0x0000);
   WriteAC97Reg(0x04,0x0000);
   WriteAC97Reg(0x06,0x0000);
   WriteAC97Reg(0x0A,0x8000);
   WriteAC97Reg(0x18,0x0000);
   //  intc_enable_interrupt(MY_INTC_BASEADDR, XPAR_MY_AC97_INTERRUPT_MASK);
}

*/

/*
void init_record(int sample_rate) {
  WriteAC97Reg(0x32, sample_rate);
  WriteAC97Reg(0x1a, 0x0000);
  WriteAC97Reg (0x1C, 0x000f);
  WriteAC97Reg(0x0E, 0x8040);
  WriteAC97Reg(0x20, 0x8000);
}
*/

Xuint16 storesound[10001];

int main (void) {
 Xuint16 soundbyte;
 Xuint32 temp;

 temp = 0;

 init_sound (22000);
 //init_record (22000);
 
 while (1) {
  microblaze_bread_datafsl(soundbyte, 0);
  
  temp = temp + 1;
 if (temp == 10001) {
   temp = 0;
  }
  
  storesound[temp] = soundbyte & 0xff80;

  if (temp == 10000) {
   soundbyte = soundbyte + storesound[0];
  }
  else {
   soundbyte = soundbyte + storesound[temp + 1];
  }

  microblaze_bwrite_datafsl(soundbyte, 0);
 }
}
  
